package com.javacodegeek;

import org.apache.commons.lang3.math.Fraction;

public class FractionExample {

	public static void main(String[] args)throws Exception {
		operations();
		comparisons();
		conversions();
		extractions();
		simpletransformations();
	}
	public static void operations(){
		System.out.println("OPERATIONS");
		
		Fraction fraA = Fraction.FOUR_FIFTHS;
		System.out.println("fraA="+fraA);
		Fraction fraB = Fraction.getFraction(6, 5);
		System.out.println("fraB= "+fraB);
		
		Fraction AaddB = fraA.add(fraB);
		System.out.println("Additon: fraA+fraB = "+AaddB);
		
		Fraction AxB=fraA.multiplyBy(fraB);
		System.out.println("MultiplyBy: fraAxfraB = "+AxB);
		
		Fraction Apow2 = fraA.pow(2);
		System.out.println("A power 2: "+Apow2);
		
		Fraction AdivB = fraA.divideBy(fraB);
		System.out.println("A divide by B: "+AdivB);
		
		Fraction AminusB = fraA.subtract(fraB);
		System.out.println("A-B: "+AminusB);
	}
	public static void comparisons(){
		System.out.println("\nCOMPARISONS");
		
		Fraction fraA = Fraction.FOUR_FIFTHS;
		Fraction fraB = Fraction.getFraction(6, 5);
		
		System.out.println("fraA="+fraA);
		System.out.println("fraB= "+fraB);
		
		int res = fraA.compareTo(fraB);
		System.out.println("fraA.compareTo(fraB): "+res);
		
		boolean boolres = fraA.equals(fraB);
		System.out.println("fraA.equals(fraB): "+boolres);
	}
	public static void conversions(){
		System.out.println("\nCONVERSIONS");
		
		Fraction fraA = Fraction.FOUR_FIFTHS;
		System.out.println("fraA: "+ fraA);
		
		double fraAdouble = fraA.doubleValue();
		System.out.println("fraA.doubleValue() : "+fraAdouble);
		
		float fraAfloat = fraA.floatValue();
		System.out.println("fraA.floatValue() : "+fraAfloat);
		
		float fraAint = fraA.intValue();
		System.out.println("fraA.intValue(): "+fraAint);
		
		Fraction frastrMixed = Fraction.getFraction("10 5/7");
		System.out.println("Fraction.getFraction(\"10 5/7\"): "+frastrMixed);
		
		Fraction frastr = Fraction.getFraction("5/7");
		System.out.println("Fraction.getFraction(\"5/7\"): "+frastr);
		
		Fraction fraDb = Fraction.getFraction(44.44);
		System.out.println("Fraction.getFraction(44.44): "+fraDb);
		
		Fraction fraND = Fraction.getFraction(6,7);
		System.out.println("Fraction.getFraction(6,7): "+fraND);
		
		Fraction fraWND = Fraction.getFraction(7,8,9); 
		System.out.println("Fraction.getFraction(7,8,9): "+fraWND);
	}
	public static void extractions(){
		System.out.println("\nEXTRACTIONS");
		
		Fraction fraA = Fraction.FOUR_FIFTHS;
		System.out.println("fraA: "+fraA);
		
		System.out.println("getDenominator(): "+fraA.getDenominator());
		
		System.out.println("getNumerator(): "+ fraA.getNumerator());
		
		System.out.println("getProperNumerator(): "+fraA.getProperNumerator());
		
		System.out.println("getProperWhole(): "+fraA.getProperWhole());
		
		System.out.println("toProperString(): "+fraA.toProperString());
	}
	public static void simpletransformations(){
		System.out.println("\nSIMPLETRANSFORAMTIONS");
		
		Fraction fraA = Fraction.FOUR_FIFTHS;
		System.out.println("fraA: "+fraA);
		
		System.out.println("fraA.negate().abs(): "+fraA.negate().abs());
		
		System.out.println("fraA.negate(): "+fraA.negate());
		
		System.out.println("fraA.invert(): "+fraA.invert());
		
		System.out.println("fraA.reduce(): "+fraA.reduce());
		
		System.out.println("fraA.getReducedFraction(20, 30): "+fraA.getReducedFraction(20, 30)); 
	}
}
